[leetcode]45. Jump Game II

91 篇文章 0 订阅
32 篇文章 0 订阅

链接:https://leetcode.com/problems/jump-game-ii/description/

 

 

Given an array of non-negative integers, you are initially positioned at the first index of the array.

Each element in the array represents your maximum jump length at that position.

Your goal is to reach the last index in the minimum number of jumps.

Example:

Input: [2,3,1,1,4]
Output: 2
Explanation: The minimum number of jumps to reach the last index is 2.
    Jump 1 step from index 0 to 1, then 3 steps to the last index.

 

方法一:动态规划(超时)

class Solution {
public:
    int jump(vector<int>& nums) {
        vector<int> dp(nums.size(), nums.size());
        dp[0] = 0;
        for (int i = 1; i < nums.size(); i++)
        {
            for (int j = 0; j < i; j++)
            {
                if (j + nums[j] >= i && dp[i] > dp[j] + 1) dp[i] = dp[j] + 1;
            }
        }
        return dp[nums.size() - 1];
    }
};

方法二:(贪心)

这道题,需要求的是最少的步数。因此需要添加step变量记录最少步数。至于什么时候step需要加1?答案是当前的i超过了前一步的最远位置。所以引入last变量记录上一步能到达的最远位置。reach、step、last的初始值均为0。当遍历到i的时候,如果i超过了last(即上一步能到达的最远位置),说明步数需要加1(即step++),此时仍需要更新last为当前最远位置reach。全程只需遍历1次数组,而且空间复杂度为常量。

 

class Solution {
public:
    int jump(vector<int>& nums) {
        int reach = 0, last = 0, step = 0,n=nums.size();
        for(int i = 0; i <= reach && i < n; ++ i)
        {
            if(i > last)
            {
                ++ step;
                last = reach;
            }
            reach = max(reach, nums[i] + i);
        }
        return reach >= n - 1 ? step : 0;
    }
};

 

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值